Index: trunk/src/VBox/Runtime/common/string/base64.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/string/base64.cpp	(revision 33529)
+++ trunk/src/VBox/Runtime/common/string/base64.cpp	(revision 33540)
@@ -229,10 +229,10 @@
  * @param   pszString       The Base64 string. Whether the entire string or
  *                          just the start of the string is in Base64 depends
- *                          on wther ppszEnd is specified or not.
+ *                          on whether ppszEnd is specified or not.
  * @param   pvData          Where to store the decoded data.
  * @param   cbData          The size of the output buffer that pvData points to.
  * @param   pcbActual       Where to store the actual number of bytes returned.
  *                          Optional.
- * @param   ppszEnd         Indicats that the string may contain other stuff
+ * @param   ppszEnd         Indicates that the string may contain other stuff
  *                          after the Base64 encoded data when not NULL. Will
  *                          be set to point to the first char that's not part of
Index: trunk/src/VBox/Runtime/common/string/memmove.asm
===================================================================
--- trunk/src/VBox/Runtime/common/string/memmove.asm	(revision 33529)
+++ trunk/src/VBox/Runtime/common/string/memmove.asm	(revision 33540)
@@ -60,5 +60,5 @@
         ; Decide which direction to perform the copy in.
         ;
-%if 1 ; keep it simpe for now.
+%if 1 ; keep it simple for now.
         cmp     xDI, xSI
         jnb     .backward
Index: trunk/src/VBox/Runtime/common/string/simplepattern.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/string/simplepattern.cpp	(revision 33529)
+++ trunk/src/VBox/Runtime/common/string/simplepattern.cpp	(revision 33540)
@@ -53,5 +53,5 @@
             case '*':
             {
-                /* collapse '*' and '?', they are supurfluous */
+                /* collapse '*' and '?', they are superfluous */
                 while ((chPat = *++pszPattern) == '*' || chPat == '?')
                     /* nothing */;
@@ -110,5 +110,5 @@
             case '*':
             {
-                /* Collapse '*' and '?', they are supurfluous. End of the pattern == match.  */
+                /* Collapse '*' and '?', they are superfluous. End of the pattern == match.  */
                 do
                 {
Index: trunk/src/VBox/Runtime/common/string/strcache.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/string/strcache.cpp	(revision 33529)
+++ trunk/src/VBox/Runtime/common/string/strcache.cpp	(revision 33540)
@@ -74,5 +74,5 @@
     /** Pointer to the main string cache structure. */
     struct RTSTRCACHEINT   *pCache;
-    /** Padding to align the entries on a 32-byte boundrary. */
+    /** Padding to align the entries on a 32-byte boundary. */
     uint32_t                au32Padding[8 - (ARCH_BITS == 64) - 4];
     /** The index of the first unused entry. */
Index: trunk/src/VBox/Runtime/common/string/strformat.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/string/strformat.cpp	(revision 33529)
+++ trunk/src/VBox/Runtime/common/string/strformat.cpp	(revision 33540)
@@ -190,5 +190,5 @@
 
     /*
-     * Determin value length
+     * Determine value length
      */
     cchValue = 0;
Index: trunk/src/VBox/Runtime/common/string/strformattype.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/string/strformattype.cpp	(revision 33529)
+++ trunk/src/VBox/Runtime/common/string/strformattype.cpp	(revision 33540)
@@ -401,5 +401,5 @@
 
 /**
- * Formats a type using a registerd callback handler.
+ * Formats a type using a registered callback handler.
  *
  * This will handle %R[type].
Index: trunk/src/VBox/Runtime/common/string/stringalloc.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/string/stringalloc.cpp	(revision 33529)
+++ trunk/src/VBox/Runtime/common/string/stringalloc.cpp	(revision 33540)
@@ -190,5 +190,5 @@
 
     /*
-     * Determin the length of each string and calc the new total.
+     * Determine the length of each string and calc the new total.
      */
     struct RTStrAAppendExNVStruct
Index: trunk/src/VBox/Runtime/common/string/strspace.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/string/strspace.cpp	(revision 33529)
+++ trunk/src/VBox/Runtime/common/string/strspace.cpp	(revision 33540)
@@ -102,5 +102,5 @@
  *
  * @returns true on success.
- * @returns false if the string collieded with an existing string.
+ * @returns false if the string collided with an existing string.
  * @param   pStrSpace       The space to insert it into.
  * @param   pStr            The string node.
Index: trunk/src/VBox/Runtime/common/string/strtonum.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/string/strtonum.cpp	(revision 33529)
+++ trunk/src/VBox/Runtime/common/string/strtonum.cpp	(revision 33540)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /** @file
- * IPRT - String To Number Convertion.
+ * IPRT - String To Number Conversion.
  */
 
@@ -93,5 +93,5 @@
  *
  * @returns iprt status code.
- *          Warnings are used to indicate convertion problems.
+ *          Warnings are used to indicate conversion problems.
  * @retval  VWRN_NUMBER_TOO_BIG
  * @retval  VWRN_NEGATIVE_UNSIGNED
@@ -217,5 +217,5 @@
  *
  * @returns iprt status code.
- *          Warnings are used to indicate convertion problems.
+ *          Warnings are used to indicate conversion problems.
  * @retval  VWRN_NUMBER_TOO_BIG
  * @retval  VWRN_NEGATIVE_UNSIGNED
@@ -273,5 +273,5 @@
  *
  * @returns iprt status code.
- *          Warnings are used to indicate convertion problems.
+ *          Warnings are used to indicate conversion problems.
  * @retval  VWRN_NUMBER_TOO_BIG
  * @retval  VWRN_NEGATIVE_UNSIGNED
@@ -308,5 +308,5 @@
  *
  * @returns iprt status code.
- *          Warnings are used to indicate convertion problems.
+ *          Warnings are used to indicate conversion problems.
  * @retval  VWRN_NUMBER_TOO_BIG
  * @retval  VWRN_NEGATIVE_UNSIGNED
@@ -360,5 +360,5 @@
  *
  * @returns iprt status code.
- *          Warnings are used to indicate convertion problems.
+ *          Warnings are used to indicate conversion problems.
  * @retval  VWRN_NUMBER_TOO_BIG
  * @retval  VWRN_NEGATIVE_UNSIGNED
@@ -395,5 +395,5 @@
  *
  * @returns iprt status code.
- *          Warnings are used to indicate convertion problems.
+ *          Warnings are used to indicate conversion problems.
  * @retval  VWRN_NUMBER_TOO_BIG
  * @retval  VWRN_NEGATIVE_UNSIGNED
@@ -447,5 +447,5 @@
  *
  * @returns iprt status code.
- *          Warnings are used to indicate convertion problems.
+ *          Warnings are used to indicate conversion problems.
  * @retval  VWRN_NUMBER_TOO_BIG
  * @retval  VWRN_NEGATIVE_UNSIGNED
@@ -482,5 +482,5 @@
  *
  * @returns iprt status code.
- *          Warnings are used to indicate convertion problems.
+ *          Warnings are used to indicate conversion problems.
  * @retval  VWRN_NUMBER_TOO_BIG
  * @retval  VWRN_NEGATIVE_UNSIGNED
@@ -539,5 +539,5 @@
  *
  * @returns iprt status code.
- *          Warnings are used to indicate convertion problems.
+ *          Warnings are used to indicate conversion problems.
  * @retval  VWRN_NUMBER_TOO_BIG
  * @retval  VWRN_TRAILING_CHARS
@@ -658,5 +658,5 @@
  *
  * @returns iprt status code.
- *          Warnings are used to indicate convertion problems.
+ *          Warnings are used to indicate conversion problems.
  * @retval  VWRN_NUMBER_TOO_BIG
  * @retval  VINF_SUCCESS
@@ -713,5 +713,5 @@
  *
  * @returns iprt status code.
- *          Warnings are used to indicate convertion problems.
+ *          Warnings are used to indicate conversion problems.
  * @retval  VWRN_NUMBER_TOO_BIG
  * @retval  VWRN_TRAILING_CHARS
@@ -748,5 +748,5 @@
  *
  * @returns iprt status code.
- *          Warnings are used to indicate convertion problems.
+ *          Warnings are used to indicate conversion problems.
  * @retval  VWRN_NUMBER_TOO_BIG
  * @retval  VINF_SUCCESS
@@ -800,5 +800,5 @@
  *
  * @returns iprt status code.
- *          Warnings are used to indicate convertion problems.
+ *          Warnings are used to indicate conversion problems.
  * @retval  VWRN_NUMBER_TOO_BIG
  * @retval  VWRN_TRAILING_CHARS
@@ -835,5 +835,5 @@
  *
  * @returns iprt status code.
- *          Warnings are used to indicate convertion problems.
+ *          Warnings are used to indicate conversion problems.
  * @retval  VWRN_NUMBER_TOO_BIG
  * @retval  VINF_SUCCESS
@@ -887,5 +887,5 @@
  *
  * @returns iprt status code.
- *          Warnings are used to indicate convertion problems.
+ *          Warnings are used to indicate conversion problems.
  * @retval  VWRN_NUMBER_TOO_BIG
  * @retval  VWRN_TRAILING_CHARS
@@ -922,5 +922,5 @@
  *
  * @returns iprt status code.
- *          Warnings are used to indicate convertion problems.
+ *          Warnings are used to indicate conversion problems.
  * @retval  VWRN_NUMBER_TOO_BIG
  * @retval  VINF_SUCCESS
Index: trunk/src/VBox/Runtime/common/string/uniread.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/string/uniread.cpp	(revision 33529)
+++ trunk/src/VBox/Runtime/common/string/uniread.cpp	(revision 33540)
@@ -152,5 +152,5 @@
  *
  * @returns Pointer to the next field.
- * @param   ppsz        Where to get and store the string postition.
+ * @param   ppsz        Where to get and store the string position.
  */
 static char *NextField(char **ppsz)
@@ -265,5 +265,5 @@
 
 /**
- * For converting the decompisition mappings field and similar.
+ * For converting the decomposition mappings field and similar.
  *
  * @returns Mapping array or NULL if none.
Index: trunk/src/VBox/Runtime/common/string/utf-8.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/string/utf-8.cpp	(revision 33529)
+++ trunk/src/VBox/Runtime/common/string/utf-8.cpp	(revision 33540)
@@ -646,5 +646,5 @@
         else
         {
-            /* generate surrugate pair */
+            /* generate surrogate pair */
             Assert((uch & (RT_BIT(7) | RT_BIT(6) | RT_BIT(5) | RT_BIT(4) | RT_BIT(3))) == (RT_BIT(7) | RT_BIT(6) | RT_BIT(5) | RT_BIT(4)));
             RTUNICP uc =           (puch[3] & 0x3f)