Index: /trunk/src/VBox/Additions/common/VBoxService/VBoxService.cpp
===================================================================
--- /trunk/src/VBox/Additions/common/VBoxService/VBoxService.cpp	(revision 33549)
+++ /trunk/src/VBox/Additions/common/VBoxService/VBoxService.cpp	(revision 33550)
@@ -136,5 +136,5 @@
              "Options:\n"
              "    -i | --interval         The default interval.\n"
-             "    -f | --foreground       Don't daemonzie the program. For debugging.\n"
+             "    -f | --foreground       Don't daemonize the program. For debugging.\n"
              "    -v | --verbose          Increment the verbosity level. For debugging.\n"
              "    -h | -? | --help        Show this message and exit with status 1.\n"
Index: /trunk/src/VBox/Additions/linux/sharedfolders/mount.vboxsf.c
===================================================================
--- /trunk/src/VBox/Additions/linux/sharedfolders/mount.vboxsf.c	(revision 33549)
+++ /trunk/src/VBox/Additions/linux/sharedfolders/mount.vboxsf.c	(revision 33550)
@@ -343,5 +343,5 @@
            "Mount the VirtualBox shared folder NAME from the host system to MOUNTPOINT.\n"
            "\n"
-           "  -w                    mount the shared folder writably (the default)\n"
+           "  -w                    mount the shared folder writable (the default)\n"
            "  -r                    mount the shared folder read-only\n"
            "  -n                    do not create an mtab entry\n"
@@ -349,5 +349,5 @@
            "\n", name);
     printf("Available mount options are:\n"
-           "     rw                 mount writably (the default)\n"
+           "     rw                 mount writable (the default)\n"
            "     ro                 mount read only\n"
            "     uid=UID            set the default file owner user id to UID\n"
Index: /trunk/src/VBox/Additions/solaris/SharedFolders/vboxfs_mount.c
===================================================================
--- /trunk/src/VBox/Additions/solaris/SharedFolders/vboxfs_mount.c	(revision 33549)
+++ /trunk/src/VBox/Additions/solaris/SharedFolders/vboxfs_mount.c	(revision 33550)
@@ -52,5 +52,5 @@
            "Mount the VirtualBox shared folder NAME from the host system to MOUNTPOINT.\n"
            "\n"
-           "  -w                    mount the shared folder writably (the default)\n"
+           "  -w                    mount the shared folder writable (the default)\n"
            "  -r                    mount the shared folder read-only\n"
            "  -o OPTION[,OPTION...] use the mount options specified\n"
@@ -58,5 +58,5 @@
     fprintf(stderr, "Available mount options are:\n"
            "\n"
-           "     rw                 mount writably (the default)\n"
+           "     rw                 mount writable (the default)\n"
            "     ro                 mount read only\n"
            "     uid=UID            set the default file owner user id to UID\n"
Index: /trunk/src/VBox/Frontends/VBoxFB/VBoxFB.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VBoxFB/VBoxFB.cpp	(revision 33549)
+++ /trunk/src/VBox/Frontends/VBoxFB/VBoxFB.cpp	(revision 33550)
@@ -39,5 +39,5 @@
             "--startvm uuid       start VM with UUID 'uuid'\n"
             "--fixedres WxHxBPP   always use fixed host resolution\n"
-            "--listhostmodes      display list of suported host display modes and exit\n"
+            "--listhostmodes      display list of supported host display modes and exit\n"
             "--scale              scale guest video mode to host video mode\n"
             "--nodirectblit       disable direct blitting, use intermediate framebuffer\n"
Index: /trunk/src/VBox/Frontends/VBoxManage/VBoxInternalManage.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VBoxManage/VBoxInternalManage.cpp	(revision 33549)
+++ /trunk/src/VBox/Frontends/VBoxManage/VBoxInternalManage.cpp	(revision 33550)
@@ -221,5 +221,5 @@
         (u64Cmd & USAGE_MODINSTALL)
         ? "  modinstall\n"
-          "       Installs the neccessary driver for the host OS\n"
+          "       Installs the necessary driver for the host OS\n"
           "\n"
         : "",
Index: /trunk/src/VBox/Frontends/VBoxShell/vboxshell.py
===================================================================
--- /trunk/src/VBox/Frontends/VBoxShell/vboxshell.py	(revision 33549)
+++ /trunk/src/VBox/Frontends/VBoxShell/vboxshell.py	(revision 33550)
@@ -3094,5 +3094,5 @@
             'colors':['Toggle colors', colorsCmd, 0],
             'snapshot':['VM snapshot manipulation, snapshot help for more info', snapshotCmd, 0],
-            'nat':['NAT (network address trasnlation engine) manipulation, nat help for more info', natCmd, 0],
+            'nat':['NAT (network address translation engine) manipulation, nat help for more info', natCmd, 0],
             'nic' : ['Network adapter management', nicCmd, 0],
             'prompt' : ['Control prompt', promptCmd, 0],
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/registration/UIRegistrationWzd.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/registration/UIRegistrationWzd.cpp	(revision 33549)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/registration/UIRegistrationWzd.cpp	(revision 33550)
@@ -642,5 +642,5 @@
          << "Angola"
          << "Anguilla"
-         << "Antartica"
+         << "Antarctica"
          << "Antigua & Barbuda"
          << "Argentina"
Index: /trunk/src/VBox/Installer/darwin/VBoxStartupItems/VirtualBox/Resources/English.lproj/Localizable.strings
===================================================================
--- /trunk/src/VBox/Installer/darwin/VBoxStartupItems/VirtualBox/Resources/English.lproj/Localizable.strings	(revision 33549)
+++ /trunk/src/VBox/Installer/darwin/VBoxStartupItems/VirtualBox/Resources/English.lproj/Localizable.strings	(revision 33550)
@@ -8,8 +8,8 @@
         <key>Loading VBoxNetFlt.kext</key>                                      <string>Loading VBoxNetFlt.kext</string>
         <key>Loading VBoxNetAdp.kext</key>                                      <string>Loading VBoxNetAdp.kext</string>
-        <key>Unloading VBoxDrv.kext</key>                                       <string>Unoading VBoxDrv.kext</string>
-        <key>Unloading VBoxUSB.kext</key>                                       <string>Unoading VBoxUSB.kext</string>
-        <key>Unloading VBoxNetFlt.kext</key>                                    <string>Unoading VBoxNetFlt.kext</string>
-        <key>Unloading VBoxNetAdp.kext</key>                                    <string>Unoading VBoxNetAdp.kext</string>
+        <key>Unloading VBoxDrv.kext</key>                                       <string>Unloading VBoxDrv.kext</string>
+        <key>Unloading VBoxUSB.kext</key>                                       <string>Unloading VBoxUSB.kext</string>
+        <key>Unloading VBoxNetFlt.kext</key>                                    <string>Unloading VBoxNetFlt.kext</string>
+        <key>Unloading VBoxNetAdp.kext</key>                                    <string>Unloading VBoxNetAdp.kext</string>
         <key>Error: /Library/Extensions/VBoxDrv.kext is missing</key>           <string>Error: /Library/Extensions/VBoxDrv.kext is missing</string>
         <key>Error: /Library/Extensions/VBoxUSB.kext is missing</key>           <string>Error: /Library/Extensions/VBoxUSB.kext is missing</string>
Index: /trunk/src/VBox/VMM/testcase/tstCompressionBenchmark.cpp
===================================================================
--- /trunk/src/VBox/VMM/testcase/tstCompressionBenchmark.cpp	(revision 33549)
+++ /trunk/src/VBox/VMM/testcase/tstCompressionBenchmark.cpp	(revision 33550)
@@ -240,5 +240,5 @@
     static const RTGETOPTDEF    s_aOptions[] =
     {
-        { "--interations",    'i', RTGETOPT_REQ_UINT32 },
+        { "--iterations",     'i', RTGETOPT_REQ_UINT32 },
         { "--num-pages",      'n', RTGETOPT_REQ_UINT32 },
         { "--page-at-a-time", 'c', RTGETOPT_REQ_UINT32 },
@@ -298,5 +298,5 @@
                          "  -h, --help\n"
                          "    Show this help page\n"
-                         "  -i, --interations <num>\n"
+                         "  -i, --iterations <num>\n"
                          "    The number of iterations.\n"
                          "  -n, --num-pages <pages>\n"